//
//      This file contains the user-defined type definitions.
//      To use it press F2 in IDA and enter the name of this file.
//

#define UNLOADED_FILE   1
#include <idc.idc>

static main(void)
{
  Enums();              // enumerations
  Structures();         // structure types
}

static Enums_0(id) {

	id = AddEnum(-1,"LICFLAGS",0x1100000);
	SetEnumBf(id,1);
	AddConstEx(id,"LF_ENABLED_BY_ALL",	0X1,	0x1);
	AddConstEx(id,"LF_USER_INSTALLABLE",	0X2,	0x2);
	AddConstEx(id,"LF_4CH_ONLY",	0X20000000,	0x20000000);
	id = AddEnum(-1,"LICEVENTS",0x1100000);
	SetEnumBf(id,1);
	AddConstEx(id,"LE_SET_NV_VALID",	0X1,	0x1);
	AddConstEx(id,"LE_SEC",	0X8,	0x8);
	id = AddEnum(-1,"eLicenseId",0x1100000);
	AddConstEx(id,"LT_NULL",	0,	-1);
	AddConstEx(id,"LT_ALL",	0X1,	-1);
	AddConstEx(id,"LT_REM",	0X2,	-1);
	AddConstEx(id,"LT_FMS",	0X3,	-1);
	AddConstEx(id,"LT_MSO",	0X4,	-1);
	AddConstEx(id,"LT_FPG",	0X5,	-1);
	AddConstEx(id,"LT_001",	0X6,	-1);
	AddConstEx(id,"LT_002",	0X7,	-1);
	AddConstEx(id,"LT_004",	0X8,	-1);
	AddConstEx(id,"LT_008",	0X9,	-1);
	AddConstEx(id,"LT_AMM",	0XA,	-1);
	AddConstEx(id,"LT_LSS",	0XB,	-1);
	AddConstEx(id,"LT_AMS",	0XC,	-1);
	AddConstEx(id,"LT_CAN",	0XD,	-1);
	AddConstEx(id,"LT_SEC",	0XE,	-1);
	AddConstEx(id,"LT_BAT",	0XF,	-1);
	AddConstEx(id,"LT_ALT",	0X10,	-1);
	AddConstEx(id,"LT_FRS",	0X11,	-1);
	AddConstEx(id,"LT_PWR",	0X12,	-1);
	AddConstEx(id,"LT_232",	0X13,	-1);
	AddConstEx(id,"LT_DSW",	0X14,	-1);
	AddConstEx(id,"LT_SGM",	0X15,	-1);
	AddConstEx(id,"LT_LMT",	0X16,	-1);
	AddConstEx(id,"LT_TEL",	0X17,	-1);
	AddConstEx(id,"LT_1MV",	0X18,	-1);
	AddConstEx(id,"LT_FRC",	0X19,	-1);
	AddConstEx(id,"LT_MST",	0X1A,	-1);
	AddConstEx(id,"LT_E00",	0X1B,	-1);
	AddConstEx(id,"LT_SND",	0X1C,	-1);
	AddConstEx(id,"LT_FLX",	0X1D,	-1);
	AddConstEx(id,"LT_DIS",	0X1E,	-1);
	AddConstEx(id,"LT_TOM",	0X1F,	-1);
	AddConstEx(id,"LT_553",	0X20,	-1);
	AddConstEx(id,"LT_CIR",	0X21,	-1);
	AddConstEx(id,"LT_HIDDEN22",	0X22,	-1);
	id = AddEnum(-1,"StartupErrors",0x1100000);
	AddConstEx(id,"SE_SoftwareFault",	0,	-1);
	AddConstEx(id,"SE_BatteryLow",	0X1,	-1);
	AddConstEx(id,"SE_BootDataError",	0X6,	-1);
	AddConstEx(id,"SE_OptionNotSupportedForModel",	0XF,	-1);
	return id;
}

//------------------------------------------------------------------------
// Information about enum types

static Enums(void) {
        auto id;
        BeginTypeUpdating(UTP_ENUM);
	id = Enums_0(id);
        EndTypeUpdating(UTP_ENUM);
}

static Structures_0(id) {
        auto mid;

	id = AddStrucEx(-1,"LICINFO",0);
	
	id = GetStrucIdByName("LICINFO");
	mid = AddStrucMember(id,"id",	0,	0x000400,	-1,	1);
	mid = AddStrucMember(id,"field_1",	0X1,	0x000400,	-1,	3);
	mid = AddStrucMember(id,"depends",	0X4,	0x20500400,	0,	4,	0XFFFFFFFF,	0,	0x000002);
	mid = AddStrucMember(id,"prefix",	0X8,	0x50000400,	0,	4);
	mid = AddStrucMember(id,"name",	0XC,	0x25500400,	0XFFFFFFFF,	4,	0XFFFFFFFF,	0,	0x000002);
	mid = AddStrucMember(id,"field_10",	0X10,	0x25500400,	0XFFFFFFFF,	4,	0XFFFFFFFF,	0,	0x000002);
	mid = AddStrucMember(id,"field_14",	0X14,	0x25500400,	0XFFFFFFFF,	4,	0XFFFFFFFF,	0,	0x000002);
	mid = AddStrucMember(id,"field_18",	0X18,	0x25500400,	0XFFFFFFFF,	4,	0XFFFFFFFF,	0,	0x000002);
	mid = AddStrucMember(id,"field_1C",	0X1C,	0x25500400,	0XFFFFFFFF,	4,	0XFFFFFFFF,	0,	0x000002);
	mid = AddStrucMember(id,"field_20",	0X20,	0x25500400,	0XFFFFFFFF,	4,	0XFFFFFFFF,	0,	0x000002);
	mid = AddStrucMember(id,"field_24",	0X24,	0x25500400,	0XFFFFFFFF,	4,	0XFFFFFFFF,	0,	0x000002);
	mid = AddStrucMember(id,"field_28",	0X28,	0x25500400,	0XFFFFFFFF,	4,	0XFFFFFFFF,	0,	0x000002);
	mid = AddStrucMember(id,"field_2C",	0X2C,	0x25500400,	0XFFFFFFFF,	4,	0XFFFFFFFF,	0,	0x000002);
	mid = AddStrucMember(id,"versions",	0X30,	0x25500400,	0XFFFFFFFF,	4,	0XFFFFFFFF,	0,	0x000002);
	mid = AddStrucMember(id,"long_name",	0X34,	0x25500400,	0XFFFFFFFF,	4,	0XFFFFFFFF,	0,	0x000002);
	mid = AddStrucMember(id,"short_name",	0X38,	0x25500400,	0XFFFFFFFF,	4,	0XFFFFFFFF,	0,	0x000002);
	mid = AddStrucMember(id,"events",	0X3C,	0x28800400,	GetEnum("LICEVENTS"),	4);
	mid = AddStrucMember(id,"flags",	0X40,	0x28800400,	GetEnum("LICFLAGS"),	4);
	return id;
}

//------------------------------------------------------------------------
// Information about structure types

static Structures(void) {
        auto id;
        BeginTypeUpdating(UTP_STRUCT);
	id = Structures_0(id);
        EndTypeUpdating(UTP_STRUCT);
}

// End of file.
